from message.message import Message


class DeleteComment(Message):
    def update_model(self, model):
        model.entry.comment = ""
        
        
class DeleteVariants(Message):
    def update_model(self, model):
        model.entry.variants = []
        
        
class DeleteRelatedEntries(Message):
    def update_model(self, model):
        model.entry.related_entries = []
        
        
class DeleteEntryLabels(Message):
    def update_model(self, model):
        model.entry.labels = []
